//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

class TArticle : public TObject {
  private:
    String FName;
    float FPrice;
    int FStock;
  public:
    __property String Name = { read = FName, write = FName };
    __property float Price = { read = FPrice, write = FPrice };
    __property int Stock = { read = FStock, write = FStock };
};

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Articles = new TStringList;
  Articles->CaseSensitive = false;
  Articles->Sorted = true;
  // the stringlist's objects must be automatically freed upon...
  // ...destroying the stringlist
  Articles->OwnsObjects = true;
  // Some housekeeping:
  edID->Text = "";
  edName->Text = "";
  edPrice->Text = "";
  edStock->Text = "";
  edFind->Text = "";
  stStatus->Caption = "";
}
//----------------------------------------------------------------------------
void __fastcall TForm1::btnAddClick(TObject *Sender)
{
  stStatus->Caption = " Adding Article ";
  edID->Text = "";
  edName->Text = "";
  edPrice->Text = "";
  edStock->Text = "";
  edID->SetFocus();  // position the cursor in edit box edID
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnOKClick(TObject *Sender)
{
  int index;
  String ID;
  ID = edID->Text;
  TArticle *Art = new TArticle;  // create Art, a TArticle object
  if (Articles->Find(ID, index))
    stStatus->Caption = " " + ID + " already exists ";
  else {
    Art->Name = edName->Text;
    Art->Price = StrToFloat(edPrice->Text);
    Art->Stock = StrToInt(edStock->Text);
    Articles->AddObject(ID, Art);
    stStatus->Caption = " Article was added ";
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnCancelClick(TObject *Sender)
{
  stStatus->Caption = " No article was added ";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnFindClick(TObject *Sender)
{
  int index;
  String ID;
  ID = edFind->Text;
  if (Articles->Find(ID, index)) {    // the position is returned in index
    stStatus->Caption = " Article was found ";
    TArticle *Art = static_cast<TArticle*>(Articles->Objects[index]);
    edID->Text = ID;
    edName->Text = Art->Name;
    edPrice->Text = FormatFloat("0.00", Art->Price);
    edStock->Text = IntToStr(Art->Stock);
  }
  else
    stStatus->Caption = " Article " + ID + " not found ";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete Articles;
}
//---------------------------------------------------------------------------



